;----------------------------------------------------------------------------------
;
;---------------------------------------------------------------------------------------------------|
.equ	ss_yy_L			= 0 
.equ	ss_yy_H			= 1 
.equ	mm_mm_L			= 2
.equ	mm_mm_H			= 3
.equ	hh_dd_L			= 4
.equ	hh_dd_H			= 5
;---------------------------------------------------------------------------------------------------|
work_proc:
			cbr MainFlags,(1<<Disp_Flag)
			clr ZH
			sbrs ControlFlags,Lock_Set
			rjmp normal
			mov ZL,choice
			sbrc ControlFlags,AlarmSet
			subi ZL,-5
			sbrc ControlFlags,CtrlSet
			subi ZL,-15

			subi ZL, low(-Table_blink*2)
			sbci ZH, high(-Table_blink*2) ; Add
			lpm Tmp_A,Z
			sts blink,Tmp_A

			sbrc ControlFlags,AlarmSet
			rjmp Alarmdisp
			sbrc ControlFlags,CtrlSet
			rjmp Set_disp

			ldi ZL,2
			mov Tmp_A,choice
			cpi Tmp_A,3
			brlo pc+2
			clr ZL
			rjmp nenormal
Alarmdisp:
			mov ZL,choice
			clr ZH
			subi ZL, low(-Table_choice*2)
			sbci ZH, high(-Table_choice*2) ; Add
			lpm Tmp_A,Z
			mov ZL,Tmp_A
			rjmp nenormal
Set_disp:
			mov ZL,choice
			subi ZL,-11
			rjmp nenormal
normal:
			sts blink,ZH
			lds ZL,DispTask
nenormal:
			lsl ZL
			clr ZH
			subi ZL, low(-TaskProcs*2)
			sbci ZH, high(-TaskProcs*2) ; Add
			lpm YL,Z+
			lpm YH,Z
			movw ZH:ZL,YH:YL
			ldi YL,Low (DigitS+6)
			ldi YH,High(DigitS+6)
			ldi Tmp_E,6
			ldi Tmp_D,10
			st -Y,Tmp_D
			dec Tmp_E
			brne pc-2

			ldi XL,Low (Bufer_RTC)
			ldi XH,High(Bufer_RTC)
			clt
			ijmp

timewiev:
			ld Tmp_E,X+
			rcall HEX_to_2BCD
			std Y+ss_yy_H,Tmp_D
			st Y,Tmp_E

			ld Tmp_E,X+
			rcall HEX_to_2BCD

			std Y+mm_mm_H,Tmp_D
			sbr Tmp_E,1<<7
			std Y+mm_mm_L,Tmp_E

			ld Tmp_E,X
			rcall HEX_to_2BCD
			std Y+hh_dd_H,Tmp_D
			sbr Tmp_E,1<<7
			std Y+hh_dd_L,Tmp_E
		ret
datewiev:
			adiw XH:XL,date
;			set
			ld Tmp_E,X+
			rcall HEX_to_2BCD

			std Y+hh_dd_H,Tmp_D
			sbr Tmp_E,1<<7
			std Y+hh_dd_L,Tmp_E

			ld Tmp_E,X+
			rcall HEX_to_2BCD
;		brts pc+2
;			sbr Tmp_D,1<<7
			std Y+mm_mm_H,Tmp_D

			sbr Tmp_E,1<<7
			std Y+mm_mm_L,Tmp_E

			ld Tmp_E,X
			rcall HEX_to_2BCD
;		brts pc+2
;			sbr Tmp_D,1<<7
			std Y+ss_yy_H,Tmp_D
			st Y,Tmp_E
		ret
weekwiev:
			adiw XH:XL,weekday
			ld Tmp_E,X+
			sbr Tmp_E,1<<7
			std Y+hh_dd_H,Tmp_E
			ld Tmp_E,X+
			rcall HEX_to_2BCD
;			sbr Tmp_D,1<<7
			std Y+mm_mm_H,Tmp_D
			sbr Tmp_E,1<<7
			std Y+mm_mm_L,Tmp_E
			ld Tmp_E,X
			rcall HEX_to_2BCD
			std Y+ss_yy_H,Tmp_D
			st Y,Tmp_E

		ret

Alarm3wiev:
			adiw XH:XL,Alarm1_hour
			ldi Tmp_C,2
			rjmp Alarm3w
Alarm1wiev:
			adiw XH:XL,Alarm0_hour
			ldi Tmp_C,1
Alarm3w:
			std Y+hh_dd_H,Tmp_C
			ld Tmp_E,X+
			rcall HEX_to_2BCD
;			sbr Tmp_D,1<<7
			std Y+mm_mm_H,Tmp_D
			sbr Tmp_E,1<<7
			std Y+mm_mm_L,Tmp_E

			ld Tmp_E,X
			rcall HEX_to_2BCD
;			sbr Tmp_D,1<<7
			std Y+ss_yy_H,Tmp_D
			st Y,Tmp_E

		ret
Alarm4wiev:
			adiw XH:XL,Alarm1_weekday
			ldi Tmp_C,2
			rjmp Alarm4w
Alarm2wiev:
			adiw XH:XL,Alarm0_weekday
			ldi Tmp_C,1
Alarm4w:
			std Y+hh_dd_H,Tmp_C
			ldi Tmp_E,0
			ldi Tmp_B,1
cutacuta:
			lds Tmp_A,alarm_mask
			and Tmp_A,Tmp_B
			brne cutacuta1
			lsl Tmp_B
			inc Tmp_E
		rjmp cutacuta
cutacuta1:

			ldi Tmp_D,1
			lds Tmp_A,alarm_mask
			ld Tmp_B,X
			and Tmp_A,Tmp_B
			brne pc+2
			ldi Tmp_D,0
			ldi Tmp_A,10;138
			std Y+ss_yy_H,Tmp_A
			tst Tmp_E
			brne pc+3
			ldi Tmp_A,9;137
			ldi Tmp_E,9
			std Y+mm_mm_H,Tmp_A
			sbr Tmp_E,1<<7
			std Y+mm_mm_L,Tmp_E

			st Y,Tmp_D
ret

Alarm41wiev:
			adiw XH:XL,Alarm1_sound
			ldi Tmp_C,2
			rjmp Alarm41w
Alarm21wiev:
			adiw XH:XL,Alarm0_sound
			ldi Tmp_C,1
Alarm41w:
			std Y+hh_dd_H,Tmp_C
			ld Tmp_E,X+

			ldi Tmp_D,8;136

			std Y+mm_mm_H,Tmp_D
			sbr Tmp_E,1<<7
			std Y+mm_mm_L,Tmp_E

			ld Tmp_E,X

			ldi Tmp_D,10;138

			std Y+ss_yy_H,Tmp_D
			st Y,Tmp_E
		ret



Set4_wiev:
			adiw XH:XL,Sound_Set
			ldi Tmp_C,5;133
			rjmp Set01_wiev
Set3_wiev:
			adiw XH:XL,Info_Set
			ldi Tmp_C,4;132
			rjmp Set01_wiev
Set0_wiev:
			adiw XH:XL,brightness
			ldi Tmp_C,1;129
Set01_wiev:
			std Y+hh_dd_H,Tmp_C
			ldi Tmp_C,10;138
			std Y+mm_mm_H,Tmp_C
			std Y+ss_yy_H,Tmp_C
			ld Tmp_C,X
			std Y+mm_mm_L,Tmp_C
		ret
Set1_wiev:
			adiw XH:XL,bright_H_on
			ldi Tmp_C,2;130
			rjmp Set21_wiev
Set2_wiev:
			adiw XH:XL,bright_H_off
			ldi Tmp_C,3;131
Set21_wiev:
			std Y+hh_dd_H,Tmp_C
;			ldi Tmp_C,128
;			std Y+mm_mm_H,Tmp_C
			ld Tmp_A,X
			rcall bright_time
			rcall HEX_to_2BCD2
;			sbr Tmp_D,1<<7
			std Y+mm_mm_H,Tmp_D
			sbr Tmp_E,1<<7
			std Y+mm_mm_L,Tmp_E
			mov Tmp_E,Tmp_A
			rcall HEX_to_2BCD2
;			sbr Tmp_D,1<<7
			std Y+ss_yy_H,Tmp_D
			st Y,Tmp_E
		ret
bright_time:
			ldi Tmp_B,10
			mul Tmp_A,Tmp_B
			movw Tmp_B:Tmp_A,r1:r0
			ldi Tmp_E,-1		; 
div_loop0:						; 
			inc Tmp_E			; 
			subi Tmp_A,low(60)	;1
			sbci Tmp_B,High(60)	;1
			brsh div_loop0		;   
			subi Tmp_A,-60		;1
		ret

;---------------------------------------------------------------------------------------------------|
term1wiev:
;			adiw XH:XL,rom_Fid_A;temperature_AL
;			ldi Tmp_C,1
;			rjmp Convert_TERM
term2wiev:
rjmp timewiev
;			adiw XH:XL,rom_Fid_B;temperature_BL
;			ldi Tmp_C,2
;Convert_TERM:
;				std Y+hh_dd_H,Tmp_C
;				ld Tmp_C,X

;				adiw XH:XL,8
;				ld Tmp_A,X+				;ls byte 
;				ld Tmp_E,X				;ms byte 
;				cpi Tmp_E,0b10001000
;				breq sensor_err
;
;				bst Tmp_E,7				;   
;				brtc positive			; + 

;				neg Tmp_A;,255			;   ls byte 
;				brcc pc+2				;     ls byte!=128
;				inc Tmp_E				; ms byte      
;				neg Tmp_E				;  ls byte=128     
;positive:	
;				cpi Tmp_C,0x10
;				brne positive1
;				lsl Tmp_A
;				rol Tmp_E
;				lsl Tmp_A
;				rol Tmp_E
;				lsl Tmp_A
;				rol Tmp_E
;positive1:	
;				mov  Tmp_C,Tmp_A		;     
;				swap Tmp_C				;
;				andi Tmp_A,0x0F			; 
;				andi Tmp_C,0x0F			; 
;				andi Tmp_E,0x07			; 
;				swap Tmp_E				;
;				or   Tmp_E,Tmp_C		;	

;				cpi Tmp_E,100			;  -55...+125
;				brlo cent_l				;   100
;sensor_err:
;				ldi Tmp_C,9				; >100  99,9
;				std Y+ss_yy_H,Tmp_C
;				brtc pc+2
;				sbr Tmp_C,1<<7
;				std Y+mm_mm_H,Tmp_C
;				sbr Tmp_C,1<<7
;				std Y+mm_mm_L,Tmp_C
;				ret
;cent_l:									;    
;				rcall HEX_to_2BCD		; 0-99  BCD
;				tst Tmp_d
;				brne pc+2
;				ldi Tmp_d,10
;				brtc pc+2
;				sbr Tmp_d,1<<7
;				std Y+mm_mm_H,Tmp_D
;				sbr Tmp_E,1<<7
;				std Y+mm_mm_L,Tmp_E

;				ldi Tmp_E,10
;				mul Tmp_A,Tmp_E
;				mov Tmp_A,r0
;				swap Tmp_A				;  16
;				andi Tmp_A,0x0F			;  16
;				std Y+ss_yy_H,Tmp_A		; 1/10 .
;			ret							;
;---------------------------------------------------------------------------------------------------|
HEX_to_2BCD:					; 0-99  BCD
			mov Tmp_D,Tmp_E				
			andi Tmp_D,0xF0		
			swap Tmp_D					
			andi Tmp_E,0x0F	
		ret
HEX_to_2BCD2:
			ldi Tmp_D,-1		; 
del_loop:						; 
			inc Tmp_D			; 
			subi Tmp_E,10		; 
			brsh del_loop		;   
			subi Tmp_E,-10		; 
		ret

;---------------------------------------------------------------------------------------------------|
TaskProcs: 	
		.dw timewiev		; [00] 
		.dw weekwiev 		; [01]		
		.dw datewiev 		; [02] 
		.dw term1wiev		; [03] 
		.dw term2wiev		; [04] 
		.dw Alarm1wiev		; [05] 
		.dw Alarm2wiev		; [06] 
		.dw Alarm21wiev		; [07]
		.dw Alarm3wiev		; [08] 
		.dw Alarm4wiev		; [09] 
		.dw Alarm41wiev		; [10]
		.dw Set0_wiev		; [11] 
		.dw Set1_wiev		; [12]
		.dw Set2_wiev		; [13]
		.dw Set3_wiev		; [14]
		.dw Set4_wiev		; [15]

;		.dw Task8		; [08]
;		.dw Task9		; [09]
;---------------------------------------------------------------------------------------------------|
Table_blink:
.db 0b00000001,0b00000010
.db 0b00000100,0b00000100
.db 0b00000010,0b00000010
.db 0b00000001,0b00000011
.db 0b00000010,0b00000001
.db 0b00000010,0b00000001
.db 0b00000011,0b00000010
.db 0b00000001,0b00000010
.db 0b00000011,0b00000011
.db 0b00000010,0b00000010

Table_choice:
.db 5,5,6,7,7,8,8,9,10,10


